﻿


BEGIN WORK;
SET TRANSACTION READ WRITE;

CREATE TABLE usuaris
(
	idusuari integer NOT NULL,
	nom character varying(128) NOT NULL,
	correu character varying(128),
	contrasenya character varying(128),
	rol character varying(128) NOT NULL,
	CONSTRAINT idusuari PRIMARY KEY (idusuari )
);


CREATE TABLE quedades
(
  
	idquedada integer NOT NULL,
	idusuari integer NOT NULL,
	titolquedada character varying(128),
	direccio character varying(128),
	dataq date,
	hora time without time zone,
	descripcio character varying(500),
	CONSTRAINT descripcio_pkey PRIMARY KEY (idquedada ),
	CONSTRAINT fk_idusuari FOREIGN KEY (idusuari)
	REFERENCES usuaris (idusuari) MATCH SIMPLE
	ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE comentaris
(
	idcomentari integer NOT NULL,
	idquedada integer NOT NULL,
	idusuari integer NOT NULL,
	nomusuari character varying(128),
	comentari character varying(500),
	CONSTRAINT pk_comentari PRIMARY KEY (idcomentari),
	CONSTRAINT fk_idquedada FOREIGN KEY (idquedada)
	REFERENCES quedades (idquedada) MATCH SIMPLE
	ON UPDATE NO ACTION ON DELETE NO ACTION,
	CONSTRAINT fk_idusuari FOREIGN KEY (idusuari)
	REFERENCES usuaris (idusuari) MATCH SIMPLE
	ON UPDATE NO ACTION ON DELETE NO ACTION   

);



CREATE TABLE anarquedada
(
	idanar integer NOT NULL,
	idquedada integer NOT NULL,
	idusuari integer NOT NULL,
	nomusuari character varying(128),
	CONSTRAINT pk_anarquedada PRIMARY KEY (idquedada, idusuari),
	CONSTRAINT fk_idquedada FOREIGN KEY (idquedada)
	REFERENCES quedades (idquedada) MATCH SIMPLE
	ON UPDATE NO ACTION ON DELETE NO ACTION,
	CONSTRAINT fk_idusuari FOREIGN KEY (idusuari)
	REFERENCES usuaris (idusuari) MATCH SIMPLE
	ON UPDATE NO ACTION ON DELETE NO ACTION   
);

INSERT INTO usuaris VALUES ('1', 'Joan Perez', 'jperez@correu.com', '1234', 'user');

INSERT INTO usuaris VALUES ('2', 'Josep Martinez', 'jmartinez@correu.com', '2234', 'admin');

INSERT INTO usuaris VALUES ('3', 'Antoni Rodriguez', 'Arodriguez@correu.com', '3234', 'user');

INSERT INTO usuaris VALUES ('4', 'Carles Masses', 'Cmasses@correu.com', '4234', 'user');

INSERT INTO usuaris VALUES ('5', 'Jordi Campas', 'jcampas@correu.com', '5234', 'user');

INSERT INTO usuaris VALUES ('6', 'David Casademunt', 'dcasademunt@correu.com', '6234', 'user');

INSERT INTO usuaris VALUES ('7', 'Pere Pastor', 'ppastor@correu.com', '7234', 'user');

INSERT INTO usuaris VALUES ('8', 'Yolanda Luna', 'yluna@correu.com', '8234', 'user');

INSERT INTO usuaris VALUES ('9', 'Isabel Preda', 'iPreda@correu.com', '9234', 'user');

INSERT INTO usuaris VALUES ('10', 'Carla Monti', 'cmonti@correu.com', '10234', 'user');



INSERT INTO quedades VALUES ('1', '1', 'Mostra de cinema', 'Port Vell de Barcelona','2/05/2012', '00:00:00', 'La pel·licula que es projectarà se FLUS FLUS Odisea');

INSERT INTO quedades VALUES ('2', '1', 'UocMic', 'Edifci MediaTIC 22@Barcelona','27/5/2012', '18:30:00', 'Xerrada sobre les TIC a la societat');

INSERT INTO quedades VALUES ('3', '2', 'Festa Carnestoltes', 'Passeig de Gracia 22 Barcelona','2/02/2012', '22:00:00', 'Els que portin disfressa una veguda de franc');

INSERT INTO quedades VALUES ('4', '10', 'Mostra de cuina Andalussa', 'C/ Cavallers Nº 34','6/04/2012', '17:15:00', 'Es serviran aperitius i es podrà apendre algunes receptes');

INSERT INTO quedades VALUES ('5', '7', 'Reunió alumni', 'Edifci MediaTIC 22@Barcelona','1/06/2012', '20:10:00', 'Taula rodona amb Abert Vilafranca especialista en Elearning');

INSERT INTO quedades VALUES ('6', '10', 'Curset de Patinatge', 'Poliesportiu La Claca c/Nou Nº 123','8/10/2012', '16:45:00', 'Heu de portar el vostre equip, no oblideu la seguretat');

INSERT INTO quedades VALUES ('7', '7', 'Esquiada a Baqueira', 'Plaça España, davant la policia','10/01/2012', '04:00:00', 'Només hi ha un autocar que sortirà de plaça España');

INSERT INTO quedades VALUES ('8', '1', 'Cinema a la fresca', 'Port Vell de Barcelona','2/08/2012', '23:10:00', 'Per gaudir de la fresca. La pel·licula serà No mires que llevo chanclas');



INSERT INTO comentaris VALUES ('1', '1', '1', 'Joan Perez', ' No havia vista mai aquesta pel·licula i em va encantar.');

INSERT INTO comentaris VALUES ('2', '2', '2', 'Josep Martinez', ' Una xerrada molt interessant.');

INSERT INTO comentaris VALUES ('3', '3', '3', 'Anotoni Rodriguez', ' La festa de carnestoltes més divertida. Vaig poder coneixer molta gent. Ho recomano.');

INSERT INTO comentaris VALUES ('4', '4', '4', 'Carles Masses', ' Rico Rico.');

INSERT INTO comentaris VALUES ('5', '5', '5', 'Jordi Campas', ' Molta gent per poder ficar idees en comú.');

INSERT INTO comentaris VALUES ('6', '6', '9', 'Isabel Preda', ' Recomanable per practicar esport.');

INSERT INTO comentaris VALUES ('7', '6', '10', 'Carla Monti', ' Encara em fa mal allà on et sentes.');

INSERT INTO comentaris VALUES ('8', '7', '1', 'Joan Perez', ' Això ho hem de repetir. No he rigut tant en la meva vida.');



INSERT INTO anarquedada VALUES ('1', '2', '1', 'Joan Perez');

INSERT INTO anarquedada VALUES ('2', '5', '1', 'Joan Perez');

INSERT INTO anarquedada VALUES ('3', '3', '1', 'Joan Perez');

INSERT INTO anarquedada VALUES ('4', '4', '3', 'Antoni Rodriguez');

INSERT INTO anarquedada VALUES ('5', '8', '4', 'Carles Masses');

INSERT INTO anarquedada VALUES ('6', '1', '4', 'Carles Masses');

INSERT INTO anarquedada VALUES ('7', '3', '4', 'Carles Masses');

INSERT INTO anarquedada VALUES ('8', '2', '10', 'Carla Monti');

INSERT INTO anarquedada VALUES ('9', '3', '10', 'Carla Monti');

INSERT INTO anarquedada VALUES ('10', '4', '10', 'Carla Monti');

INSERT INTO anarquedada VALUES ('11', '5', '8', 'Yolanda Luna');

INSERT INTO anarquedada VALUES ('12', '6', '8', 'Yolanda Luna');

INSERT INTO anarquedada VALUES ('13', '7', '8', 'Yolanda Luna');

INSERT INTO anarquedada VALUES ('14', '8', '6', 'David Casademunt');

INSERT INTO anarquedada VALUES ('15', '7', '6', 'David Casademunt');










COMMIT;
