/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package meeting.business.DB;
import meeting.business.modeldades.*;   
import java.util.List;
import java.util.ArrayList;
import java.sql.Connection;
import java.util.logging.*;
import java.sql.SQLException;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

/**
 *
 * @author Josep Jiménez
 * Classe que gestiona l'accés a la base de dades
 */
public class DBdades {
    static Logger logger = Logger.getLogger(DBdades.class.getName());   
    /**
    * Cercar quedades per identificador
    * @param idquedada identificador de quedada
    * @return Retorna una llista de Cuocadadade
    */
    public Cuocdada quedadaById(int idquedada){
        Connection con = getconection();
        Cuocdada ret = new Cuocdada();
        //Preparem la petició
        PreparedStatement pquedades = null;
        // Preparem els resultats
        ResultSet rquedada = null;

        try{
            //****** cerca quedada pre la id 
            // Confeccionem l'estament
            String lquedada = ("SELECT * FROM quedades where idquedada ='"+idquedada+"'") ; 
            // Preparem el estament
            pquedades = con.prepareStatement(lquedada);
            //******************************************** 
            // Executem i guardem els resultats
            rquedada = pquedades.executeQuery();

            while (rquedada.next()){
                ret.setIdquedada(rquedada.getInt(1));
                ret.setIdusuari(rquedada.getInt(2));
                ret.setTitol(rquedada.getString(3));
                ret.setDireccio(rquedada.getString(4));
                ret.setData(rquedada.getString(5));
                ret.setHora(rquedada.getString(6));
                ret.setDescripcio(rquedada.getString(7));
            }

        }catch(SQLException e){

            DBaccess.closeConnection(con);
        }

        DBaccess.closeConnection(con);
        return ret;
    }
    /**
    * Llistar totes les quedades
    * @return Retorna una llista de totes les quedades de la BD
    */    
    public List allQuedades(){
        Connection con = getconection();
        List ret = new ArrayList();
        //Preparem la petició
        PreparedStatement pquedades = null;
        // Preparem els resultats
        ResultSet rqueades = null;

        try{
            //****** cercar tots els usuaris de la base de dades 
            // Confeccionem el primer estament per treure els monitors amb 0 hores
            String lquedada = "SELECT * FROM quedades  ORDER BY dataq ASC" ; 
            // Preparem el estament
            pquedades = con.prepareStatement(lquedada);
            //******************************************** 
            // Executem i guardem els resultats
            rqueades = pquedades.executeQuery();

            while (rqueades.next()){
                Cuocdada qu = new Cuocdada();
                qu.setIdquedada(rqueades.getInt(1));
                qu.setIdusuari(rqueades.getInt(2));
                qu.setTitol(rqueades.getString(3));
                qu.setDireccio(rqueades.getString(4));
                qu.setData(rqueades.getString(5));
                qu.setHora(rqueades.getString(6));
                qu.setDescripcio(rqueades.getString(7));
                ret.add(qu);
            }

        }catch(SQLException e){

            DBaccess.closeConnection(con);
        }

        DBaccess.closeConnection(con);
        return ret;
   }    
        
    /**
    * Cercar quedades a partir d'una data
    * @param data Data a partir de la qual s'ha de generar la llista de Cuocdades
    * @return Retorna una llista de quedades a partir d'una data
    */        
    public List quedadesByData(String data){
        Connection con = getconection();
        List ret = new ArrayList();
        //Preparem la petició
        PreparedStatement pquedades = null;
        // Preparem els resultats
	ResultSet rqueades = null;
        
        try{
            //****** Cercar les quedades a partir d'una data 
            // Confeccionem l'estament
            String lquedada = "SELECT * FROM quedades where dataq >= '"+data+"'"+" ORDER BY dataq ASC"; 
            // Preparem el estament
	    pquedades = con.prepareStatement(lquedada);
            //******************************************** 
            // Executem i guardem els resultats
            rqueades = pquedades.executeQuery();
            
            while (rqueades.next()){
                Cuocdada qu = new Cuocdada();
                qu.setIdquedada(rqueades.getInt(1));
                qu.setIdusuari(rqueades.getInt(2));
                qu.setTitol(rqueades.getString(3));
                qu.setDireccio(rqueades.getString(4));
                qu.setData(rqueades.getString(5));
                qu.setHora(rqueades.getString(6));
                qu.setDescripcio(rqueades.getString(7));
                ret.add(qu);
            }

        }catch(SQLException e){
            
            DBaccess.closeConnection(con);
        }

        DBaccess.closeConnection(con);
        return ret;
    }    
 
    /**
    * Cercar quedades entre dates
    * @param  datainici Data de inici de la cerca de Cuocdades
    * @param datafinal Data final de la cerca de Cuocdades 
    * @return Retorna una llista de quedades entre dues dates
    */    
    public List quedadesBetweenData(String datainici, String datafinal ){
        Connection con = getconection();
        List ret = new ArrayList();
        //Preparem la petició
        PreparedStatement pquedades = null;
        // Preparem els resultats
	ResultSet rqueades = null;
        
        try{
            //****** Cercar les quedades a partir d'una data 
            // Confeccionem l'estament
            String lquedada = "SELECT * FROM quedades where dataq >= '"+datainici+"'"+" AND dataq <= '"+datafinal+"'"+" ORDER BY dataq ASC" ; 
            // Preparem el estament
	    pquedades = con.prepareStatement(lquedada);
            //******************************************** 
            // Executem i guardem els resultats
            rqueades = pquedades.executeQuery();
            
            while (rqueades.next()){
                Cuocdada qu = new Cuocdada();
                qu.setIdquedada(rqueades.getInt(1));
                qu.setIdusuari(rqueades.getInt(2));
                qu.setTitol(rqueades.getString(3));
                qu.setDireccio(rqueades.getString(4));
                qu.setData(rqueades.getString(5));
                qu.setHora(rqueades.getString(6));
                qu.setDescripcio(rqueades.getString(7));
                ret.add(qu);
            }

        }catch(SQLException e){
            
            DBaccess.closeConnection(con);
        }
        DBaccess.closeConnection(con);
        return ret;
        
    }
    /**
    * Cercar comentaris d'una quedada
    * @param idquedada identificador de la quedada de la qual s'han de cercar comentaris
    * @return Retorna una llista de comentaris associats a una quedada
    */
   public List comentarisByIdQuedada(int idquedada){
        Connection con = getconection();
        List ret = new ArrayList();
        //Preparem la petició
        PreparedStatement pcoments = null;
        // Preparem els resultats
	ResultSet rcoments = null;
        
        try{
            //****** Cercar comentaris d'una quedada 
            // Confeccionem l'estament
            String lcoment = "SELECT * FROM comentaris where idquedada = '"+idquedada+"'"+" ORDER BY idcomentari ASC"; 
            // Preparem el estament
	    pcoments = con.prepareStatement(lcoment);
            //******************************************** 
            // Executem i guardem els resultats
            rcoments = pcoments.executeQuery();
            
            while (rcoments.next()){
                Comentaris com = new Comentaris();
                com.setIdcomentari(rcoments.getInt(1));
                com.setIdquedada(rcoments.getInt(2));
                com.setIdusuari(rcoments.getInt(3));
                com.setNomusuari(rcoments.getString(4));
                com.setComentari(rcoments.getString(5));
                ret.add(com);
            }
        }catch(SQLException e){
            DBaccess.closeConnection(con);
        }
        DBaccess.closeConnection(con);
        return ret;
    }    

    /**
    * Afegir un comentari a una quedada
    * @param idquedada Identificador de la quedada per inserir el comentari
    * @param idusuari Identificador de l'usuari que fa el comentari
    * @param nomusuari Nom del usuari que fa el comentari
    * @param comentari Comentari sobre la quedada
    * @return retorna true si hi ha un error durant la inserció del comentari
    */   
    public boolean afegirComentari(int idquedada, int idusuari , String nomusuari, String comentari){
        Connection con = getconection();
        boolean ret = false;
        //Preparem la petició
        PreparedStatement pcoments = null;
        // Preparem els resultats
	ResultSet rcoments = null;
        
        try{
            //****** l'identificador més alt
            // Confeccionem l'estament
            String lid = "SELECT idcomentari FROM comentaris ORDER BY idcomentari DESC LIMIT 1"; 
            // Preparem el estament
	    pcoments = con.prepareStatement(lid);
            //******************************************** 
            // Executem i guardem els resultats
            rcoments = pcoments.executeQuery();
            
            int maxidecomentari=0;
            while (rcoments.next()){
                maxidecomentari=(rcoments.getInt(1));
            }
            
            nomusuari= nomusuari.replace("'", "´");
            comentari= comentari.replace("'", "´");
            //****** Cercar comentaris d'una quedada 
            // Confeccionem l'estament
            String lcoment = "INSERT INTO comentaris VALUES ('"+(maxidecomentari+1)+"', '"+idquedada+"', '"+idusuari+"', '"+nomusuari+"', '"+ comentari+"');"; 
            // Preparem el estament
	    pcoments = con.prepareStatement(lcoment);
            //******************************************** 
            // Executem i guardem els resultats
            pcoments.executeUpdate();
 
        }catch(SQLException e){
            DBaccess.closeConnection(con);
            ret=true;
        }
        DBaccess.closeConnection(con);
        return ret;
    }    

    /**
    * Apuntar un usuari a una quedada
     * @param idquedada Identificador de la quedada que a la qual l'usuari vol apuntar-s'hi
     * @param idusuari Identificador de l'usari que es vol apuntar a una quedada
     * @param nomusuari Nom del usuari que es vol apuntar a la quedada que es pasa com a parèmtre
     * @return Retorna true si hi ha un error durant la inserció de l'usuari.
    */    
    public boolean afegirUsuariAQuedada(int idquedada, int idusuari , String nomusuari){
        Connection con = getconection();
        boolean ret = false;
        //Preparem la petició
        PreparedStatement panar = null;
        // Preparem els resultats
	ResultSet ranar = null;
        
        try{
            //****** l'identificador més alt
            // Confeccionem l'estament
            String lid = "SELECT idanar FROM anarquedada ORDER BY idanar DESC LIMIT 1"; 
            // Preparem el estament
	    panar = con.prepareStatement(lid);
            //******************************************** 
            // Executem i guardem els resultats
            ranar = panar.executeQuery();
            
            int maxideanar=0;
            while (ranar.next()){
                maxideanar=(ranar.getInt(1));
            }

            //****** Inserrir l'usuari 
            // Confeccionem l'estament
            String lcoment = "INSERT INTO anarquedada VALUES ('"+(maxideanar+1)+"', '"+idquedada+"', '"+idusuari+"', '"+nomusuari+"');"; 
            // Preparem el estament
	    panar = con.prepareStatement(lcoment);
            //******************************************** 
            // Executem i guardem els resultats
            panar.executeUpdate();
 
        }catch(SQLException e){
            DBaccess.closeConnection(con);
            ret=true;
        }
        DBaccess.closeConnection(con);
        return ret;
    }

    /**
    * Llista d'usuaris que assiteixen a una quedada
    * @param idquedada Identificador de la quedada 
    * @return Retorna una llista d'usuaris apuntats a la quedada pasada com a paràmetre.
    */    
   public List quiVa(int idquedada){
        Connection con = getconection();
        List ret = new ArrayList();
        //Preparem la petició
        PreparedStatement pquiva = null;
        // Preparem els resultats
	ResultSet rpquiva = null;
        
        try{
            //****** Cercar llista de qui va a una trobada 
            // Confeccionem l'estament
            String lcoment = "SELECT * FROM anarquedada where idquedada = '"+idquedada+"'"+" ORDER BY idquedada ASC"; 
            // Preparem el estament
	    pquiva = con.prepareStatement(lcoment);
            //******************************************** 
            // Executem i guardem els resultats
            rpquiva = pquiva.executeQuery();
            
            while (rpquiva.next()){
                Usuari us = new Usuari();
                us.setNom(rpquiva.getString(4));
                ret.add(us);
            }
        }catch(SQLException e){
            DBaccess.closeConnection(con);
        }
        DBaccess.closeConnection(con);
        return ret;
    }    
            
    /**
    * Afegir una nova quedada
    * @param idusuari Identificador de l'usuari que genera la nova quedada
    * @param titolquedada Titol que descriu la quedada
    * @param direccio Direcció de la quedada
    * @param data Data en que es durà a terme la quedada
    * @param hora Hora d'inici de la quedada
    * @param descripcio Descripció llarga en què consisteix la quedada
    * @return Retorna true si hi ha un error durant la insersió de la quedada
    */        
    public boolean afegirQuocdada(int idusuari, String titolquedada, String direccio, String data, String hora, String descripcio){
        Connection con = getconection();
        boolean ret = false;
        //Preparem la petició
        PreparedStatement pquedada = null;
        // Preparem els resultats
	ResultSet rquedada = null;
       
        try{
            //****** l'identificador més alt
            // Confeccionem l'estament
            String lid = "SELECT idquedada FROM quedades ORDER BY idquedada DESC LIMIT 1"; 
            // Preparem el estament
	    pquedada = con.prepareStatement(lid);
            //******************************************** 
            // Executem i guardem els resultats
            rquedada = pquedada.executeQuery();
            
            int maxidquedada=0;
            while (rquedada.next()){
                maxidquedada=(rquedada.getInt(1));
            }
            titolquedada= titolquedada.replace("'", "´");
            direccio= direccio.replace("'", "´");
            descripcio= descripcio.replace("'", "´");
            
            //****** Cercar comentaris d'una quedada 
            // Confeccionem l'estament
            String lquedada = "INSERT INTO quedades VALUES ('"+(maxidquedada+1)+"', '"+idusuari+"', '"+titolquedada+"', '"+direccio+"', '"+ data+"', '"+ hora+"', '"+ descripcio+"');"; 
            // Preparem el estament
	    pquedada = con.prepareStatement(lquedada);
            //******************************************** 
            // Executem i guardem els resultats
            pquedada.executeUpdate();
 
        }catch(SQLException e){
            DBaccess.closeConnection(con);
            ret=true;
        }
        DBaccess.closeConnection(con);
        return ret;
    }    
    
    /**
    * Llistat d'usuaris
    * @return Retorna la llista d'usuaris subscrits a la web
    */    
    public List llistaUsuaris(){
        Connection con = getconection();
        List ret = new ArrayList();
        //Preparem la petició
        PreparedStatement pusuaris = null;
        // Preparem els resultats
	ResultSet rusuari = null;
        
        try{
            //****** cercar tots els usuaris de la base de dades 
            // Confeccionem el primer estament per treure els monitors amb 0 hores
            String lusuaris = "SELECT * FROM Usuaris " ; 
            // Preparem el estament
	    pusuaris = con.prepareStatement(lusuaris);
            //******************************************** 
            // Executem i guardem els resultats
            rusuari = pusuaris.executeQuery();
            
            while (rusuari.next()){
                Usuari us = new Usuari();
                us.setIdusuari(rusuari.getInt(1));
                us.setNom(rusuari.getString(2));
                us.setCorreu(rusuari.getString(3));
                us.setPassword(rusuari.getString(4));
                us.setRol(rusuari.getString(5));
                ret.add(us);
            
            }

        }catch(SQLException e){
            
            DBaccess.closeConnection(con);
        }

        DBaccess.closeConnection(con);
        return ret;
    }

    /**
    * Cercar un usuari pel seu correu
    * @param correu Correo de l'usari a cercar
    * @return Retorna l'usuari trobat, null si no en troba cap. 
    */    
    public Usuari cercaUsuariPerCorreu(String correu){
        Connection con = getconection();
        Usuari retusuari = new Usuari();
        //Preparem la petició
        PreparedStatement pusuari = null;
        // Preparem els resultats
	ResultSet rusuari = null;
        
        try{
            //****** cercar usuari per correu
            String susuari = "SELECT * FROM usuaris WHERE correu = "+ "'" + correu + "'" ; 
            // Preparem el estament
	    pusuari = con.prepareStatement(susuari);
            //******************************************** 
            // Executem i guardem els resultats
            rusuari = pusuari.executeQuery();
            
            while (rusuari.next()){
                retusuari.setIdusuari(rusuari.getInt(1));
                retusuari.setNom(rusuari.getString(2));
                retusuari.setCorreu(rusuari.getString(3));
                retusuari.setPassword(rusuari.getString(4));
                retusuari.setRol(rusuari.getString(5));
            }

        }catch(SQLException e){
            
            DBaccess.closeConnection(con);
        }

        DBaccess.closeConnection(con);
        return retusuari;
    }
    /**
    * Realitzar la connexió a la BD
    * @return Retorna una connexió a la base dedades.
    */    
    private Connection getconection(){
        Connection con = null;
        try{
            con = DBaccess.getConnection();
        } catch(Exception e){
            logger.info("Error en l'accés a la Base de Dades");            
        }
    return con;
    }
    
}
