package meeting.business.modeldades;

/**
 * Classe que modela les dades de un comentari sobre una quedada
 * @author Josep Jiménez
 */
public class Comentaris {

    int idcomentari;
    int idquedada;
    int idusuari;
    String nomusuari;
    String comentari;

    /**
     * Obtenir l'identificador del comentari
     * @return Identificador del comentari
     */
    public int getIdcomentari() {
        return idcomentari;
    }

    /**
     * Actualitzar l'identificador del comentari.
     * @param idcomentari Identtificador del comentari
     */
    public void setIdcomentari(int idcomentari) {
        this.idcomentari = idcomentari;
    }

    /**
     * Obtenir identtifacdor de la quedada a que correspon el comentari
     * @return Retorna l'identificador de la quedada que correspon al comentari
     */
    public int getIdquedada() {
        return idquedada;
    }

    /**
     * Actualitzar l'identificador de la quedada que correspon al comentari
     * @param idquedada Ientificador de la quedada que correspon al comentari
     */
    public void setIdquedada(int idquedada) {
        this.idquedada = idquedada;
    }

    /**
     * Obtenir l'identificador de l'usuari que ha realitzat el comentari
     * @return Retorna l'identificador de l'usuari que ha realitzat el comentari
     */
    public int getIdusuari() {
        return idusuari;
    }

    /**
     * Actualitzar l'identificador de l'usuari que ha realitzat el comentari
     * @param idusuari Identificador de l'usuari que ha realitzat el comentari
     */
    public void setIdusuari(int idusuari) {
        this.idusuari = idusuari;
    }

    /**
     * Obtenir el nom de l'usuari que ha realitzat el comentari
     * @return Retorna el nom de l'usuari que ha realitzat el comentari
     */
    public String getNomusuari() {
        return nomusuari;
    }

    /**
     * Actualitzar el nom de l'usuari que ha realitzat el comentari
     * @param nomusuari Nom de l'usuari que ha realitzat el comentari
     */
    public void setNomusuari(String nomusuari) {
        this.nomusuari = nomusuari;
    }

    /**
     * Obtenir el comentari realitzat sobre la quedada
     * @return Retorna el comentari realitzat sobre la quedada
     */
    public String getComentari() {
        return comentari;
    }

    /**
     * Actualitzar el comentari realitzat sobre la quedada
     * @param comentari Comentari sobre la quedada
     */
    public void setComentari(String comentari) {
        this.comentari = comentari;
    }
}
