package meeting.business.modeldades;

/**
 * Classe que modela les dades de una quedada
 * @author Josep Jiménez
 */
public class Cuocdada {
    int idquedada;
    int idusuari;
    String titol;
    String direccio;
    String data;
    String hora;
    String descripcio;

    /**
     * Obtenir la data en que es durà a terme una quedada
     * @return Retorna la data en que es durà a terme una quedada
     */
    public String getData() {
        return data;
    }

    /**
     * Actualitzar la data en que es durà a terme una quedada
     * @param data Data en que es durà a terme una quedada
     */
    public void setData(String data) {
        this.data = data;
    }

    /**
     * Obtenir la descripció de una quedada
     * @return Retorna la descripció de una quedada
     */
    public String getDescripcio() {
        return descripcio;
    }

    /**
     * Actualitza la descripció de una quedada
     * @param descripcio Descriu les característiques de una quedad
     */
    public void setDescripcio(String descripcio) {
        this.descripcio = descripcio;
    }

    /**
     * Obtebir l'hora de una quedada
     * @return L'hora d'una quedada
     */
    public String getHora() {
        return hora;
    }

    /**
     * Actualitza l'hora d'una quedada
     * @param hora Hora de la quedada
     */
    public void setHora(String hora) {
        this.hora = hora;
    }

    /**
     * Obtenir l'identificador de la quedada
     * @return Retorna l'identificador de la quedada
     */
    public int getIdquedada() {
        return idquedada;
    }

    /**
     * Actualitza l'identificador de la quedada
     * @param idquedada Identificador de la quedada
     */
    public void setIdquedada(int idquedada) {
        this.idquedada = idquedada;
    }

    /**
     * Obtenir l'identificador de l'usuari que ha creat la quedada
     * @return Retorna l'identificador de l'usuari que ha creat la quedada
     */
    public int getIdusuari() {
        return idusuari;
    }

    /**
     * Actualitza l'identificador de l'usuari que ha creat la quedada
     * @param idusuari Identificador de l'usuari que ha creat la quedada
     */
    public void setIdusuari(int idusuari) {
        this.idusuari = idusuari;
    }

    /**
     * Retonar el títol genèric de la quedada
     * @return Títol genèric de la quedada
     */
    public String getTitol() {
        return titol;
    }

    /**
     * Obtenir títol genèric de la quedada
     * @param titol El títol genèric de la quedada
     */
    public void setTitol(String titol) {
        this.titol = titol;
    }

    /**
     * Obtenir l'adreça on es durà a terme la quedada
     * @return Adreça de la quedada
     */
    public String getDireccio() {
        return direccio;
    }

    /**
     * Actualitzar l'adreça on es durà a terme la quedada
     * @param direccio Adreça de la quedada
     */
    public void setDireccio(String direccio) {
        this.direccio = direccio;
    }

    
}
