package SappFramework.Annotation;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Annotació per definir que un paràmetre d'una acció correspon un objecte controlador del'aplicació.
 * @author Josep Jiménez
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.PARAMETER)
public @interface ParamApp {
    /**
    * <li> El parèmtre ha de ser un controlador de l'aplicació.</li>
    * <li> El nom del paràmetre ha de coincidir amb el parèmtre del web.</li>
    */
    String nom() default "";  
    /**
    * Nom del controlador a que correspon el paràmetre
    */
    String nomcclasse() default "";  

}