package SappFramework.Annotation;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * <li> Annotació per definir que el paràmetre a rebre serà la request de la pàgina en que s'ha demanat l'acció.</li>
 * <li> El parèmtre sempre ha de ser del tipus HttpServletReques.</li>
 * @author Josep Jiménez
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.PARAMETER)
public @interface ParamRequest {
    /**
    * <li> El paràmetre nom no te utilitzat. Es pot fer servir com a indicació. El spaaFramework no l'utilitzarà.</li>
    */
    String nom() default "";                               

}