package SappFramework.Annotation;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Annotació per definir els paraàmetres rebuts de la pàgina.
 * <li> El parèmtre ha d'estar definit com atribut als atributs del controlador.</li> 
 * <li> El nom del paràmetre ha de coincidir amb el parèmtre del web.</li>  
 * @author Josep Jiménez
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.PARAMETER)
public @interface ParamWeb {
    /**
    * <li> Nom del paràmetre que es rep des de la web.</li> 
    * <li> El nom del paràmetre ha de coincidir amb el parèmtre del web.</li> 
    */
    String nom() default "";                               

}