package SappFramework.Annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * <li> Annotació per definir els rols dels usuaris que poden executar l'acció.</li>
 * <li> Si el rol d'un usuari coindideix amb algún rol de la llista l'acció es podrà executar. </li>
 * @author Josep Jiménez
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
public @interface Rol {
    /**
    * Llista de rols que poden executar l'acció 
    */
    String[] rols() default "";
 
    
}