package SappFramework.Eines;

/**
 * Classe per definir constants del Framework que s'utilitzaran a tota l'aplicació
 * @author Josep Jimenez
 */
public class Constants {
    /** 
     * <li>Mode d'excució d'un contenidor per determinar el cicle de vida del controlador i les seves accions.</li>
     * <li>L'obecte controlador es guardarà al "HashMap" de nom "Sapp" que s'envia al web a trav´s del SappFramework.</li>
     * <li>L'atribut "Sapp" correspon a un "HashMap" on els identificadors son el noms del controladors que s'hagin configurat a l'apliació.</li>
     * <li>En mode sessió la duració és la sessió client.</li>
     */
    public static final String TIPUS_EXECUCIO_SESSIO = "SESSIO";
    
    /** 
     * <li>Mode d'excució d'un contenidor per determinar el cicle de vida del controlador i les seves accions.</li>
     * <li>En mode petició/reposata la durada no s'allarga més enllà de la petició, el controlador no es guarda a la sessió d'usuari però si es passa al "HashMap" "Sapp" de la resposta a una acció.</li>
     * <li>L'atribut "Sapp" correspon a un "HashMap" on els identificadors son el noms del controladors que s'hagin configurat a l'apliació.</li>
     */
    public static final String TIPUS_EXECUCIO_PR = "PETICIO_RESPOSTA"; 
}
