package SappFramework.Gestio;

import java.lang.reflect.Method;

/**
 * Modela els atributs i paràmetres de la postexecució d'una acció del framework.
 * @author Josep Jiménez
 */
public class Cposproces {

    private String nom;
    private String retornError;
    private String contentType;
    private Method metode;
    private Method accio;
    private Cparam[] params;
    private int numordre;

    /**
     * Retorna la redefinició del nom de la postexecució.
     * @return El nom de la postexecució.
     */
    public String getNom() {
        return nom;
    }

    /**
     * Actualització del nom de la postexecució.
     * @param nom Nom de la postexecució.
     */
    public void setNom(String nom) {
        this.nom = nom;
    }

    /**
     * Retorna el mètode de la postexecució.
     * @return Mètode de la postexecució.
     */
    public Method getMetode() {
        return metode;
    }

    /**
     * Defineix el mètode de la postexecució.
     * @param metode Mètode de la postexecució.
     */
    public void setMetode(Method metode) {
        this.metode = metode;
    }

     /**
     * Retorna la pàgina de retorn si hi ha  error a la postexecució.
     * @return Pàgina de retorn de la postexecució en cas d'error.
     */
    public String getRetornError() {
        return retornError;
    }

   /**
     * Defineix la pàgina de retorn de la postexecució.
     * @param retornerror Pàgina de retorn de la postexecució.
     */
    public void setRetornError(String retornerror) {
        this.retornError= retornerror;
    }
    
    
    /**
     * Retorna el mètode de L'ació en que se executa la postexecució.
     * @return Mètode de l'acció que executa la postexecució.
     */
    public Method getAccio() {
        return accio;
    }

    /**
     * Determina el mètode l'acció de la postexecució.
     * @param accio Mètode de l'acció de la postexecució.
     */
    public void setCAcció(Method accio) {
        this.accio = accio;
    }
 
    /**
     * Retorna un array amb els paràmetres d'entrada de la postexecució.
     * @return Paràmetres de la postexecució.
     */
    public Cparam[] getParametres() {
        return params;
    }

    /**
     * Defineix l'array dels paràmetres d'entrada la postexecució.
     * @param params Paràmetres de la postexecució.
     */
    public void setParametres(Cparam[] params) {
        this.params = params;
    }
        /**
     * Retorna el número d'ordre d'execució.
     * @return Número d'ordre de l'execució.
     */
    public int getNumOrdre() {
        return numordre;
    }

    /**
     * Defineix el número d'odre de l'execució.
     * @param numordre Número d'odre de l'execució.
     */
    public void setNumOrdre(int numordre) {
        this.numordre = numordre;
    }

     /**
     * @return the contentType
     */
    public String getContentType() {
        return contentType;
    }

    /**
     * @param contentType the contentType to set
     */
    public void setContentType(String contentType) {
        this.contentType = contentType;
    }
}
