package SappFramework.Interfaces;


/**
 * <li> Interficie Usuari.</li>
 * <li> Defineix les dades d'un usuari, es podrà recarregar aquesta intefície amb  una redefinició a durant la implementació de l'aplicació.</li>
 * @author Josep Jiménez
 */

public interface IUsuari {

    /**
     * Obtenir el correu d'un usuari
     * @return Retorna el correu d'un usuari
     */
    public String getCorreu();
    
    /**
     * Actualitzar el correu d'un usuari
     * @param correu Correu d'un usuari
     */
    public void setCorreu(String correu);

    /**
     * Obtenir l'identificador d'un usuari
     * @return Retorna l'indentificador d'un usuari
     */
    public int getIdusuari();

    /**
     * Actualitzar l'identificador d'un usuari
     * @param idusuari Identificaador de l'usuari
     */
    public void setIdusuari(int idusuari);

    /**
     * Obtenir el nom d'un usuari
     * @return Retorna el nom de l'usuari
     */
    public String getNom();

    /**
     * Actualitzar el nom d'un usuari
     * @param nom Nom de l'usuari
     */
    public void setNom(String nom);

    /**
     * Obtenir el password d'un usuari
     * @return Retorna el password d'un usuari
     */
    public String getPassword();

    /**
     * Actualitzar el password d'un usuari
     * @param password Password de l'usuari
     */
    public void setPassword(String password);
    
    /**
     * Obttenir la sessió en que s'ha validat un usuari
     * @return Sessió en que s'ha validat l'usuari
     */
    public String getSessionId();

    /**
     * Actualitza la sessió en que s'ha validat un usuari
     * @param session Sessió en que es valida un usuari
     */
    public void setSessionId(String session);
    
    /**
     * Obtenir si un usuari està validat en la sessió
     * @param validat Validació de sessió
     */
    public void setValidat (boolean validat);
    
    /**
     * Actualitzar si un usuari està validat en una sessió
     * @return Validació d'usuari
     */
    public boolean getValidat ();
    
    /**
     * Obtebir el rol d'un usuari
     * @return Rol d'un usuari
     */
    public String getRol();

    /**
     * Actualitzar el rol d'un usuari
     * @param rol Rol de l'usuari
     */
    public void setRol(String rol);
    
}