package SappFramework.Tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;
import java.util.Map;
import java.util.HashMap;

import java.lang.reflect.Method;
import java.util.logging.*;
/**
 * <li>Gestió del tag per poder accedir a un atribut d'un controlador.</li>
 * <li>Es composa de dos paràmetres:</li>
 * <li>controlador: Nom del controlador del qual es vol extreure l'atribut.</li>
 * <li>atribut: Nom de l'atribut per llegir. Si es vol accedir a un atribut d'un objecte que conté el controlador s'haurà de separar per per un punt el nom de l'objecte del seu atribut.</li>
 * @author Josep Jiménez
 */
public class GetDada extends TagSupport {
        static Logger logger = Logger.getLogger(GetDada.class.getName());	
	private String controlador;
        private String atribut;
	
            public int doStartTag() {
                ServletRequest request = pageContext.getRequest();
                   
                //Extreure els atributs
                String[] atributs = atribut.split("\\."); 
                //Treure els espais i ficar la primera en majuscules
                for (int i=0; i<atributs.length; i++){
                    atributs[i] = atributs[i].replace(" ", "");
                    atributs[i]=atributs[i].substring(0,1).toUpperCase() + atributs[i].substring(1);
                }
                try {
                    Map<String, Object> datapage = (HashMap <String, Object>) (request.  getAttribute("Sappf"));
                    Object contr = datapage.get(controlador);
                    Method[] met = new Method[atributs.length];
                    Object[] obj = new Object[atributs.length]; 
                    met[0] = contr.getClass().getMethod(("get"+atributs[0]), (Class<?>[])new Class<?>[0]);
                    obj[0] =met[0].invoke(contr, (Object[])new Object[0]);

                    for (int i=1; i< atributs.length; i++){
                            met[i] = obj[i-1].getClass().getMethod(("get"+atributs[i]), (Class<?>[])new Class<?>[0]);
                            obj[i] =met[i].invoke(obj[i-1], (Object[])new Object[0]);
                        }
                    String sortida ="";
                    if (obj[atributs.length-1].getClass().equals(String.class)){
                                sortida = (String) obj[atributs.length-1];
                    }
                    else if (obj[atributs.length-1].getClass().equals(Integer.class)){
                                Integer v = (Integer) obj[atributs.length-1];
                                sortida =v.toString();
                    }                            
                    JspWriter out = pageContext.getOut();
                    out.print(sortida);
                    
                    }catch(Exception e) {
                          logger.warning("Error No trobat el controlador "+controlador+" o l'atribut "+ atribut );   
                    }
                    return(EVAL_BODY_INCLUDE);
            }

            public String getAtribut() {
                return atribut;
            }

            public void setAtribut(String atribut) {
                this.atribut = atribut;
            }

            public String getControlador() {
                return controlador;
            }

            public void setControlador(String controlador) {
                this.controlador = controlador;
            }

            public int doEndTag() {
                    return(EVAL_PAGE); // Continue with rest of JSP page
            }
		
}
