package SappFramework.Tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;
import java.util.Map;
import java.util.HashMap;
import java.util.List;
import java.util.Iterator;

import java.lang.reflect.Method;
import java.util.logging.*;

/**
 * <li>Gestió del tag per poder crear una taula a partir d'una llista d'un controlador.</li>
 * <li>Es composa de cinc paràmetres:</li>
 * <li>titolllista: Títol que apareixerà a la capçalera de la taula</li>
 * <li>controlador: Nom del controlador del qual es vol extreure la llista.</li>
 * <li>nomllista: Nom de l'atribut llista a partir del qual s'ha de crear la taula.</li>
 * <li>nomcolumnes: identificador que apareixerà al capdamunt de cada columna, es separen per comes si n'hi ha més d'un</li>
 * <li>nomatributs: Nom dels atributs que s'han de seleccionar de la llista per ser visualitzats a la taula es separen per comes si n'hi ha més d'un. Han de coincidir amb el nomm dels atributs de la llista.</li>
 * <li>Ha d'ahver el mateix nombre d'elements al paràmetre "nomcolumnes" i "nomatributs"</li> 
 * @author Josep Jiménez
 */

public class LlistaNorm extends TagSupport {
        static Logger logger = Logger.getLogger(LlistaNorm.class.getName());
        private String titolllista;
	private String controlador;
        private String nomllista;
        private String nomcolumnes;
        private String nomatributs;
	
        public int doStartTag() {
                ServletRequest request = pageContext.getRequest();
                
                //Convertir la primera lletra en majuscules per que coincidir amb els mètodes get i set
                nomllista= nomllista.substring(0,1).toUpperCase() + nomllista.substring(1);
                
                
                //Extreure els atributs
                String[] atributs = nomatributs.split(",");
                //Treure els espais i ficar la primera en majuscules
                for (int i=0; i<atributs.length; i++){
                    atributs[i] = atributs[i].replace(" ", "");
                    atributs[i]=atributs[i].substring(0,1).toUpperCase() + atributs[i].substring(1);
                }
                //Extreure els nom de les columnes
                String[] nomcol = nomcolumnes.split(",");

                //Comprovar que el nombre d'atributs i columnes coincideix
                if (atributs.length != nomcol.length){
                    logger.warning("ERROR: El nombre d'atributs i columnes no coincideix" );
                     return(EVAL_BODY_INCLUDE);
                }
                
                StringBuffer sbsortida= new StringBuffer();
                try {
                    Map<String, Object> datapage = (HashMap <String, Object>) (request.  getAttribute("Sappf"));
                    Object o = datapage.get(controlador);
                    Method met = o.getClass().getMethod(("get"+nomllista), (Class<?>[])new Class<?>[0]);
                    Object o2 =met.invoke(o, (Object[])new Object[0]);
                    List llista = (List) o2;
                    
                    if (llista !=null){
                        //Generar primera fila amb els noms de les columnes
                        sbsortida.append("<table border =\"1\">");
                        sbsortida.append("<caption><font color =\"blue \"face=\"geneva,verdana,arial\" size=\"3\">"+titolllista+"</font></caption>");
                        sbsortida.append("<thead> ");
                        
                        for(int t=0; t <nomcol.length; t++ ){
                             sbsortida.append("<th scope=\"col\">"+nomcol[t]+"</th>");
                        }
                        sbsortida.append("</thead><tr> ");                              
                        
                        Iterator itl = llista.iterator();
                        while (itl.hasNext()){
                            sbsortida.append("<tr>");   
                            //Llegir element de la llista
                            Object llistai = itl.next();
                            for(int natr =0; natr < atributs.length; natr++  ){
                                Class ff = llistai.getClass();
                                Method met4 = llistai.getClass().getMethod(("get"+atributs[natr]), (Class<?>[])new Class<?>[0]);
                                Object o4 =met4.invoke(llistai, (Object[])new Object[0]);
                                 String valordada ="";
                                if (o4.getClass().equals(String.class)){
                                    valordada = (String) o4;
                                }
                                else if (o4.getClass().equals(Integer.class)){
                                    Integer v = (Integer) o4;
                                    valordada =v.toString();
                                }
                                    sbsortida.append("<td>"+valordada+"</td>");
                            }
                        }
                        sbsortida.append("</tr>");
                    }
                     sbsortida.append("</table>");
                    JspWriter out = pageContext.getOut();
                    out.print(sbsortida);
                } catch(Exception e) {
                    logger.warning("Error No trobat el controlador "+controlador+" o els atributs no son correctes" );   
                }
                return(EVAL_BODY_INCLUDE);
            }

        public String getTitolllista() {
            return titolllista;
        }

        public void setTitolllista(String titolllista) {
            this.titolllista = titolllista;
        }

        public String getControlador() {
            return controlador;
        }

        public void setControlador(String controlador) {
            this.controlador = controlador;
        }

        public String getNomatributs() {
            return nomatributs;
        }

        public void setNomatributs(String nomatributs) {
            this.nomatributs = nomatributs;
        }

        public String getNomcolumnes() {
            return nomcolumnes;
        }

        public void setNomcolumnes(String nomcolumnes) {
            this.nomcolumnes = nomcolumnes;
        }

        public String getNomllista() {
            return nomllista;
        }

        public void setNomllista(String nomllista) {
            this.nomllista = nomllista;
        }

        public int doEndTag() {
                return(EVAL_PAGE); // Continue with rest of JSP page
        }
		
}
